// generated by Fast Light User Interface Designer (fluid) version 1.0300

#ifndef p4fliconv_fl_hpp
#define p4fliconv_fl_hpp
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Progress.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Output.H>

class Plus4FLIConvGUI {
public:
  friend class Plus4FLIConvGUI_Display; 
  friend class Plus4FLIConvGUI_TED7360; 
private:
  Plus4FLIConvGUI_Display *display; 
  Plus4FLIConvGUI_TED7360 *ted; 
  Plus4FLIConv::FLIConfiguration& config; 
  Fl_Window *emulatorWindow; 
  unsigned char *imageFileData; 
  std::string imageFileName; 
  bool busyFlag; 
  bool stopFlag; 
  bool previewEnabled; 
  bool fileChangedFlag; 
  bool fileNotSavedFlag; 
  bool confirmStatus; 
  bool c64PaletteChangedFlag; 
  Fl_File_Chooser *browseFileWindow; 
  std::string imageFileDirectory; 
  std::string configDirectory; 
  std::string prgFileDirectory; 
  Plus4Emu::ConfigurationDB guiConfig; 
  Plus4Emu::Timer emulationTimer; 
  Plus4FLIConv::PRGData prgData; 
  unsigned int prgEndAddress; 
  void init_(); 
public:
  void updateDisplay(double t = 0.02); 
  bool confirmMessage(const char *msg); 
  void errorMessage(const char *msg); 
  bool browseFile(std::string& fileName, std::string& dirName, const char *pattern, int type, const char *title); 
  void applyConfigurationChanges(); 
  static void setWidgetColorToPlus4Color(Fl_Widget *o, int c); 
  void updateConfigWindow(); 
  void openImageFile(); 
private:
  void updateImageDisplay(); 
public:
  void savePRGFile(); 
  void setBusyFlag(bool newState); 
private:
  static void fltkCheckCallback(void *userData); 
  static void progressMessageCallback(void *userData, const char *msg); 
  static bool progressPercentageCallback(void *userData, int n); 
  static void pixelStoreCallback(void *userData, int xc, int yc, float y, float u, float v); 
public:
  void run(); 
  Plus4FLIConvGUI(Plus4FLIConv::FLIConfiguration& config_) ;
  Fl_Window *mainWindow;
private:
  void cb_mainWindow_i(Fl_Window*, void*);
  static void cb_mainWindow(Fl_Window*, void*);
public:
  Fl_Button *openImageButton;
private:
  void cb_openImageButton_i(Fl_Button*, void*);
  static void cb_openImageButton(Fl_Button*, void*);
public:
  Fl_Button *savePRGButton;
private:
  void cb_savePRGButton_i(Fl_Button*, void*);
  static void cb_savePRGButton(Fl_Button*, void*);
  void cb_Options_i(Fl_Button*, void*);
  static void cb_Options(Fl_Button*, void*);
  void cb_Preview_i(Fl_Check_Button*, void*);
  static void cb_Preview(Fl_Check_Button*, void*);
public:
  Fl_Progress *progressDisplay;
  Fl_Button *stopButton;
private:
  void cb_stopButton_i(Fl_Button*, void*);
  static void cb_stopButton(Fl_Button*, void*);
  void cb_About_i(Fl_Button*, void*);
  static void cb_About(Fl_Button*, void*);
public:
  Fl_Double_Window *configWindow;
private:
  void cb_configWindow_i(Fl_Double_Window*, void*);
  static void cb_configWindow(Fl_Double_Window*, void*);
public:
  Fl_Choice *conversionTypeValuator;
private:
  void cb_conversionTypeValuator_i(Fl_Choice*, void*);
  static void cb_conversionTypeValuator(Fl_Choice*, void*);
public:
  Fl_Value_Input *verticalSizeValuator;
private:
  void cb_verticalSizeValuator_i(Fl_Value_Input*, void*);
  static void cb_verticalSizeValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *borderColorValuator;
private:
  void cb_borderColorValuator_i(Fl_Value_Input*, void*);
  static void cb_borderColorValuator(Fl_Value_Input*, void*);
public:
  Fl_Box *borderColorDisplay;
  Fl_Value_Input *scaleXValuator;
private:
  void cb_scaleXValuator_i(Fl_Value_Input*, void*);
  static void cb_scaleXValuator(Fl_Value_Input*, void*);
public:
  Fl_Check_Button *fixedAspectRatioValuator;
  Fl_Value_Input *scaleYValuator;
private:
  void cb_scaleYValuator_i(Fl_Value_Input*, void*);
  static void cb_scaleYValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *offsetXValuator;
private:
  void cb_offsetXValuator_i(Fl_Value_Input*, void*);
  static void cb_offsetXValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *offsetYValuator;
private:
  void cb_offsetYValuator_i(Fl_Value_Input*, void*);
  static void cb_offsetYValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *yMinValuator;
private:
  void cb_yMinValuator_i(Fl_Value_Input*, void*);
  static void cb_yMinValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *yMaxValuator;
private:
  void cb_yMaxValuator_i(Fl_Value_Input*, void*);
  static void cb_yMaxValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *saturationMultValuator;
private:
  void cb_saturationMultValuator_i(Fl_Value_Input*, void*);
  static void cb_saturationMultValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *saturationPowValuator;
private:
  void cb_saturationPowValuator_i(Fl_Value_Input*, void*);
  static void cb_saturationPowValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *gammaCorrectionValuator;
private:
  void cb_gammaCorrectionValuator_i(Fl_Value_Input*, void*);
  static void cb_gammaCorrectionValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *monitorGammaValuator;
private:
  void cb_monitorGammaValuator_i(Fl_Value_Input*, void*);
  static void cb_monitorGammaValuator(Fl_Value_Input*, void*);
public:
  Fl_Choice *ditherModeValuator;
private:
  void cb_ditherModeValuator_i(Fl_Choice*, void*);
  static void cb_ditherModeValuator(Fl_Choice*, void*);
public:
  Fl_Value_Input *ditherLimitValuator;
private:
  void cb_ditherLimitValuator_i(Fl_Value_Input*, void*);
  static void cb_ditherLimitValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *ditherDiffusionValuator;
private:
  void cb_ditherDiffusionValuator_i(Fl_Value_Input*, void*);
  static void cb_ditherDiffusionValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Slider *multiColorQualityValuator;
private:
  void cb_multiColorQualityValuator_i(Fl_Value_Slider*, void*);
  static void cb_multiColorQualityValuator(Fl_Value_Slider*, void*);
public:
  Fl_Choice *xShift0Valuator;
private:
  void cb_xShift0Valuator_i(Fl_Choice*, void*);
  static void cb_xShift0Valuator(Fl_Choice*, void*);
public:
  Fl_Choice *xShift1Valuator;
private:
  void cb_xShift1Valuator_i(Fl_Choice*, void*);
  static void cb_xShift1Valuator(Fl_Choice*, void*);
public:
  Fl_Choice *outputFileFormatValuator;
private:
  void cb_outputFileFormatValuator_i(Fl_Choice*, void*);
  static void cb_outputFileFormatValuator(Fl_Choice*, void*);
public:
  Fl_Value_Slider *prgCompressionLevelValuator;
private:
  void cb_prgCompressionLevelValuator_i(Fl_Value_Slider*, void*);
  static void cb_prgCompressionLevelValuator(Fl_Value_Slider*, void*);
public:
  Fl_Check_Button *luminance1BitModeValuator;
private:
  void cb_luminance1BitModeValuator_i(Fl_Check_Button*, void*);
  static void cb_luminance1BitModeValuator(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *disableInterpolationValuator;
private:
  void cb_disableInterpolationValuator_i(Fl_Check_Button*, void*);
  static void cb_disableInterpolationValuator(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *enablePALValuator;
private:
  void cb_enablePALValuator_i(Fl_Check_Button*, void*);
  static void cb_enablePALValuator(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *disableFLIEffectsValuator;
private:
  void cb_disableFLIEffectsValuator_i(Fl_Check_Button*, void*);
  static void cb_disableFLIEffectsValuator(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *noLuminanceInterlaceValuator;
private:
  void cb_noLuminanceInterlaceValuator_i(Fl_Check_Button*, void*);
  static void cb_noLuminanceInterlaceValuator(Fl_Check_Button*, void*);
public:
  Fl_Choice *colorInterlaceModeValuator;
private:
  void cb_colorInterlaceModeValuator_i(Fl_Choice*, void*);
  static void cb_colorInterlaceModeValuator(Fl_Choice*, void*);
public:
  Fl_Choice *luminanceSearchModeValuator;
private:
  void cb_luminanceSearchModeValuator_i(Fl_Choice*, void*);
  static void cb_luminanceSearchModeValuator(Fl_Choice*, void*);
public:
  Fl_Value_Input *lumSearchModeParamValuator;
private:
  void cb_lumSearchModeParamValuator_i(Fl_Value_Input*, void*);
  static void cb_lumSearchModeParamValuator(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *mcColorErrorScaleValuator;
private:
  void cb_mcColorErrorScaleValuator_i(Fl_Value_Input*, void*);
  static void cb_mcColorErrorScaleValuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color0Display;
  Fl_Value_Input *c64Color0Valuator;
private:
  void cb_c64Color0Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color0Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color1Display;
  Fl_Value_Input *c64Color1Valuator;
private:
  void cb_c64Color1Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color1Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color2Display;
  Fl_Value_Input *c64Color2Valuator;
private:
  void cb_c64Color2Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color2Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color3Display;
  Fl_Value_Input *c64Color3Valuator;
private:
  void cb_c64Color3Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color3Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color4Display;
  Fl_Value_Input *c64Color4Valuator;
private:
  void cb_c64Color4Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color4Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color5Display;
  Fl_Value_Input *c64Color5Valuator;
private:
  void cb_c64Color5Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color5Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color6Display;
  Fl_Value_Input *c64Color6Valuator;
private:
  void cb_c64Color6Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color6Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color7Display;
  Fl_Value_Input *c64Color7Valuator;
private:
  void cb_c64Color7Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color7Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color8Display;
  Fl_Value_Input *c64Color8Valuator;
private:
  void cb_c64Color8Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color8Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color9Display;
  Fl_Value_Input *c64Color9Valuator;
private:
  void cb_c64Color9Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color9Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color10Display;
  Fl_Value_Input *c64Color10Valuator;
private:
  void cb_c64Color10Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color10Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color11Display;
  Fl_Value_Input *c64Color11Valuator;
private:
  void cb_c64Color11Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color11Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color12Display;
  Fl_Value_Input *c64Color12Valuator;
private:
  void cb_c64Color12Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color12Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color13Display;
  Fl_Value_Input *c64Color13Valuator;
private:
  void cb_c64Color13Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color13Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color14Display;
  Fl_Value_Input *c64Color14Valuator;
private:
  void cb_c64Color14Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color14Valuator(Fl_Value_Input*, void*);
public:
  Fl_Box *c64Color15Display;
  Fl_Value_Input *c64Color15Valuator;
private:
  void cb_c64Color15Valuator_i(Fl_Value_Input*, void*);
  static void cb_c64Color15Valuator(Fl_Value_Input*, void*);
  void cb_Load_i(Fl_Button*, void*);
  static void cb_Load(Fl_Button*, void*);
  void cb_Save_i(Fl_Button*, void*);
  static void cb_Save(Fl_Button*, void*);
  void cb_Reset_i(Fl_Button*, void*);
  static void cb_Reset(Fl_Button*, void*);
  void cb_Apply_i(Fl_Button*, void*);
  static void cb_Apply(Fl_Button*, void*);
  void cb_OK_i(Fl_Button*, void*);
  static void cb_OK(Fl_Button*, void*);
public:
  Fl_Double_Window *aboutWindow;
  Fl_Output *aboutWindowText;
private:
  void cb_OK1_i(Fl_Button*, void*);
  static void cb_OK1(Fl_Button*, void*);
public:
  Fl_Double_Window *confirmMessageWindow;
private:
  void cb_confirmMessageWindow_i(Fl_Double_Window*, void*);
  static void cb_confirmMessageWindow(Fl_Double_Window*, void*);
public:
  Fl_Box *confirmMessageText;
private:
  void cb_OK2_i(Fl_Button*, void*);
  static void cb_OK2(Fl_Button*, void*);
  void cb_Cancel_i(Fl_Button*, void*);
  static void cb_Cancel(Fl_Button*, void*);
public:
  Fl_Double_Window *errorMessageWindow;
  Fl_Box *errorMessageText;
private:
  void cb_OK3_i(Fl_Button*, void*);
  static void cb_OK3(Fl_Button*, void*);
public:
  ~Plus4FLIConvGUI();
};
#endif
